import { Material, Object3D, Points, WebGLRenderer } from 'three';
import { NodeRenderView } from '../tree/NodeRenderView';
import { Batch, BatchUpdateRange, GeometryType } from './Batch';
export default class PointBatch implements Batch {
    id: string;
    subtreeId: string;
    renderViews: NodeRenderView[];
    private geometry;
    batchMaterial: Material;
    mesh: Points;
    private gradientIndexBuffer;
    get bounds(): import("three").Box3;
    constructor(id: string, subtreeId: string, renderViews: NodeRenderView[]);
    updateBatchObjects(): void;
    get renderObject(): Object3D;
    get geometryType(): GeometryType;
    getCount(): number;
    setBatchMaterial(material: Material): void;
    onUpdate(deltaTime: number): void;
    onRender(renderer: WebGLRenderer): void;
    setVisibleRange(...ranges: BatchUpdateRange[]): void;
    getVisibleRange(): BatchUpdateRange;
    /**
     * This is the first version for multi draw ranges with automatic fill support
     * In the near future, we'll re-sort the index buffer so we minimize draw calls to
     * a minimmum. For now it's ok
     */
    setDrawRanges(...ranges: BatchUpdateRange[]): void;
    insertDrawRanges(...ranges: BatchUpdateRange[]): void;
    removeDrawRanges(id: string): void;
    private getDrawRangeCollision;
    autoFillDrawRanges(): void;
    private flattenGroups;
    resetDrawRanges(): void;
    buildBatch(): void;
    getRenderView(index: number): NodeRenderView;
    getMaterialAtIndex(index: number): Material;
    private makePointGeometry;
    private updateGradientIndexBufferData;
    private updateGradientIndexBuffer;
    purge(): void;
}
